<template>
	<form @submit="submit" class="mt-4">
		<div>
			<label class="inline-block w-24">Email:</label>
			<input
				type="email"
				required
				class="
					border border-gray-400
					w-48 my-1 px-2 h-8
					mx-2 rounded-md
				"
				v-model="email"
			/>
		</div>
		<div>
			<label class="inline-block w-24">Password:</label>
			<input
				type="password"
				required
				class="
					border border-gray-400
					w-48 my-1 px-2 h-8
					mx-2 rounded-md
				"
				v-model="password"
			/>
		</div>
		<input
			v-show="loginMode"
			type="submit"
			value="Login"
			class="mt-4 bg-blue-200 py-1 px-3 h-8 rounded-md"
		/>
		<input
			v-show="!loginMode"
			type="submit"
			value="Register"
			class="mt-4 bg-blue-200 py-1 px-3 h-8 rounded-md"
		/>
		<p class="mt-2 text-red-500">{{ warning }}</p>
		<p v-show="loading" class="mt-2 text-blue-500">Loading....</p>
	</form>
	<button @click="switchMode" class="mt-8 px-4 py-2 bg-yellow-500 rounded-md">
		Switch to {{ loginMode ? "Register" : "Login" }}
	</button>
</template>

<script>
import { ref } from "@vue/runtime-core";
import { useStore } from "vuex";
import { useRouter } from "vue-router";
import { LOGGING_IN } from "../../store/actions";

export default {
	name: "Login",
	setup() {
		const store = useStore();

		const router = useRouter();

		const loginMode = ref(true);
		const email = ref("");
		const password = ref("");
		const warning = ref("");
		const loading = ref(false)

		const switchMode = () => {
			loginMode.value = !loginMode.value;
			email.value = "";
			password.value = "";
			warning.value = "";
		};

		const submit = (e) => {
			e.preventDefault();
			warning.value = "";

			if (email.value === "" || password.value === "") {
				warning.value = "email and Password don't empty";
			} else {
				loading.value = true;

				store.dispatch(LOGGING_IN, {
					email: email.value,
					password: password.value,
					loginMode: loginMode.value
				}).then((data) => {
					loading.value = false;
					console.log(data)
					router.push({ name: "home" });
				}).catch((error) => {
					loading.value = false;
					warning.value = error;
				});
			}
		};

		return { submit, switchMode, email, password, loginMode, warning, loading };
	},
};
</script>

<style>
</style>